'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extractSet;

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _pickBy = require('lodash/pickBy');

var _pickBy2 = _interopRequireDefault(_pickBy);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isDefined(value) {
  return value !== null && typeof value !== 'undefined';
} /**
   * @copyright   2017, Miles Johnson
   * @license     https://opensource.org/licenses/MIT
   * 
   */

function extractSet(data, format, fields = []) {
  const { name, display, hexcode, codepoint, shortnames } = data;
  const [shortname] = shortnames;
  const unicode = data[display];

  switch (format) {
    default:
    case _constants.EXPANDED:
      return (0, _pickBy2.default)(data, isDefined);

    case _constants.STANDARD:
      return (0, _pickBy2.default)({
        name,
        unicode,
        hexcode,
        codepoint,
        shortname
      }, isDefined);

    case _constants.COMPACT:
      return (0, _pickBy2.default)({
        unicode,
        hexcode,
        shortname
      }, isDefined);

    case _constants.CUSTOM:
      return (0, _pick2.default)(data, fields);
  }
}