'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fromUnicodeToHex;

var _constants = require('./constants');

const BASE_HEXADECIMAL = 16; /**
                              * @copyright   2017, Miles Johnson
                              * @license     https://opensource.org/licenses/MIT
                              * 
                              */

const HEX_WIDTH = 4;

function fromUnicodeToHex(unicode, strip = true) {
  const hexcode = [];

  for (const codepoint of unicode) {
    let hex = codepoint.codePointAt(0).toString(BASE_HEXADECIMAL).toUpperCase();

    while (hex.length < HEX_WIDTH) {
      hex = `0${hex}`;
    }

    if (!strip || strip && !hex.match(_constants.SEQUENCE_REMOVAL_PATTERN)) {
      hexcode.push(hex);
    }
  }

  return hexcode.join('-');
}